// *********************************************************
// Header file ListIterator.h.
// Used in the iterator version of the ADT list.
// *********************************************************
#include "ListNode.h" // Definition of ListNode and
                      // ListItemType; ListNode declares 
                      // ListIterator as a friend class
class ListIterator
{
public:
   ListIterator(List *container, ListNode *nodePtr);

   const ListItemType & operator*();
   ListIterator operator++();    // prefix ++

   bool operator==(const ListIterator& rhs) const;
   bool operator!=(const ListIterator& rhs) const;
   
   friend class List;

private:
   const List *container; // ADT associated with iterator
   ListNode *cur;         // current location in collection
}; // end class